package com.sun.xml.internal.ws.api.pipe;

import java.util.Iterator;
import com.sun.xml.internal.ws.util.pipe.StandalonePipeAssembler;
import com.sun.xml.internal.ws.util.ServiceFinder;
import com.sun.xml.internal.ws.api.BindingID;
import java.util.logging.Logger;

public abstract class PipelineAssemblerFactory
{
    private static final Logger logger;
    
    public PipelineAssemblerFactory() {
    }
    
    public abstract PipelineAssembler doCreate(BindingID p0);
    
    public static PipelineAssembler create(ClassLoader classLoader, BindingID bindingId) {
        for (PipelineAssemblerFactory factory : ServiceFinder.find(PipelineAssemblerFactory.class, classLoader)) {
            PipelineAssembler assembler = factory.doCreate(bindingId);
            if (assembler != null) {
                PipelineAssemblerFactory.logger.fine(factory.getClass() + " successfully created " + assembler);
                return assembler;
            }
            continue;
        }
        return new StandalonePipeAssembler();
    }
    
    static {
        logger = Logger.getLogger(PipelineAssemblerFactory.class.getName());
    }
}
